---
title: "We're hiring!"
author: Nim Team
excerpt: "This is your chance to get to work with one of the leading experts in compiler
development, meta programming and language design."
---

## Become a Nim core developer

Nim is proving to be an increasingly reliable workhorse for every day
programming jobs since you can productively use it both client-side and
server-side thanks to its innovate language core that maps well to lower
level representations like C and LLVM as well as to high level
JavaScript. It comes as no surprise then, that Nim is growing and looking
for new core developers!

As a member of the team, you have a direct impact on design and feature enhancements
of the Nim programming language.

Nim covers a broad range of topics leading to a constant stream of challenges
which require you to continually be innovative with an evolving set of technologies.

So if you seek a new challenge, if you are experienced in production quality
compiler development, if you enjoy working from home, don't hesitate to
apply.


## Requirements

This is your chance to get to work with one of the leading experts in compiler
development, meta programming and language design. Here are our requirements:

- Fluent in C++, C, Nim. You should have some Nim related github projects to
  make it easier for us to judge your skills.
- Basic knowledge of the lexing, parsing and semantic checking passes a compiler
  consists of.
- Knowledge in Nim's standard library; the standard library covers parsers,
  asynchronous programming, dealing with time and timezones, IO, multi-threaded
  programming, networking, as well as knowledge about the Posix and the
  Windows API.
- Knowledge about type theory and the foundations of programming languages.
  We are not just looking for programmers, Nim's specification also needs to
  be improved and extended.
- Experience in IDE development, there is no reason Nim's tooling can't rival
  the state-of-the-art when it comes to error messages, auto-completion and
  automatic refactorings.

Note that you don't have to fulfill *every* one of these criteria; Nim is a
large project with plenty of work covering diverse topics and our requirements
reflect this.


## How to apply

Send your application to `jobs@nim-lang.org`.
